import time
def add_elem(elem, list1, circle):
    if elem in list1:
        return list1, False
    list1.append(elem)
    if circle - elem in list1:
        return list1, False
    list1.append(circle - elem)
    return list1, True

def append_all(new_d_i, d, all_d, circle):
    # append list of all distances by new distances from new_d_i
    d_ext = []
    d_ext.extend(d)
    d_ext.append(new_d_i)
    all_d_ext = []
    all_d_ext.extend(all_d)
    sum_d = 0
    for elem in reversed(d_ext):
        sum_d += elem
        all_d_ext, succ = add_elem(sum_d, all_d_ext, circle)
        if not succ:
            return d_ext, all_d_ext, False        
    return d_ext, all_d_ext, True

def max_range(d, all_d, circle, numberTrees):
    # len(d) = number of already found distances
    # numberTrees-len(d) distances are unknown => return max value of unknown distances
    # find numberTrees-len(d)-1 minimal distances not contained in all_d 
    # max unknown distance <=  sum_i d_i + numberTrees-len(d)-1 * min_elements_not_in_all_d
    sum = 0
    unknown = numberTrees - len(d)
    #print(unknown)
    for d_i in d:
        sum += d_i
    i = 0
    for d_i in range(1,circle):
        if i >= unknown-1:
            break
        if d_i not in all_d:
            sum += d_i
            i += 1
    #print(circle-sum)
    return circle - sum

def rekursive_step(range_min, range_max, distances, all_distances, circle, numberTrees):
    for d_i in range(range_min,range_max):
        # w.l.o.g distances[0] = min(distances)
        if len(distances)==0 or (len(distances)>0 and d_i > distances[0]):
            if d_i not in all_distances:
                distances_i, all_d_i, succeeded = append_all(d_i, distances, all_distances, circle)
                if not succeeded:
                    continue    
                max_i = max_range(distances_i, all_d_i, circle, numberTrees)
                if(len(distances_i) == numberTrees-1):
                    last_distance = max_i
                    #exclude rotations
                    if last_distance < distances_i[0]:
                        continue
                    #exclude reflections
                    if last_distance > distances_i[1]:
                        continue
                    distances_i.append(last_distance)
                    #distances_i.sort()
                    print(distances_i)
                else:
                    rekursive_step(range_min, max_i+1, distances_i, all_d_i, circle, numberTrees)
start = time.time()
rekursive_step(1,4+1,[], [], 57, 8)
print(time.time() - start)